#!/usr/local/bin/ruby
#
# եȤƬʬΥǡ
#
# usage: ruby makeheader.rb <ե̾>
#

require "sizes.rb"

subrmapbase = $subrmapoffset

fontname = ARGV[0]
fontname =~ /[^0-9]+([0-9]+)[^0-9]*/
uidoffset = $1.to_i * 100
uid = 7100000 + uidoffset

print <<"__EOM__"
%!PS-Adobe-3.0 Resource-CIDFont
%%DocumentNeededResources: ProcSet (CIDInit)
%%IncludeResource: ProcSet (CIDInit)
%%BeginResource: CIDFont (#{fontname})
%%Title: (#{fontname} Mojikyo Asia1 0)
%%Version: 1.000
%  (C1E0A0)

/CIDInit /ProcSet findresource begin

20 dict begin

/CIDFontName /#{fontname} def
/CIDFontVersion 1.000 def
/CIDFontType 0 def

/CIDSystemInfo 3 dict dup begin
  /Registry (Mojikyo)  def
  /Ordering (Asia1) def
  /Supplement 0 def
end def

/FontBBox [0 -300 1000 1000] readonly def

/UIDBase #{uid} def
/XUID [255 11 #{uid}] def

/FontInfo 2 dict dup begin
  /Notice
    ((c) Copyright 1999-2000 Mojikyo Institute / (c) Copyright 2000 YOKOTA Hiroshi  This CID font is converted by CID-Maker from Type1 font) def
  /FullName (#{fontname}) def
end readonly def
/CIDMapOffset 0 def

/FDBytes 1 def
/GDBytes 3 def
/CIDCount #{$cidcount} def

/FDArray #{$numfiles} array

__EOM__

for i in 0..($numfiles-1)
  k = sprintf("%02d", i+6)
  i_subrmapoffset = subrmapbase + $subrelementsize * i

  print <<"__EOM__"
dup #{i}
%ADOBeginFontDict
14 dict
  begin
  /FontName /#{fontname}-M#{k} def
  /FontType 1 def
  /FontMatrix [ 0.001 0 0 0.001 0 0 ] def
  /PaintType 0 def

  %ADOBeginPrivateDict
  /Private 25 dict dup
    begin
    /MinFeature {16 16} readonly def
    /LanguageGroup 1 def
    /BlueValues [ -250 -250 1100 1100 ] def
    /BlueScale 0.0396271 def
    /BlueFuzz 1 def
    /BlueShift 7 def
    /StdHW [ 76 ] def
    /StdVW [ 86 ] def
    /StemSnapH [ 76 ] def
    /StemSnapV [ 86 ] def
    /lenIV 4 def

    /OtherSubrs
    [ { } { } { }
      { systemdict /internaldict known not
          { pop 3 }
          { 1183615869 systemdict /internaldict get exec dup
            /startlock known
              { /startlock get exec }
              { dup /strtlck known { /strtlck get exec } { pop 3 } ifelse }
            ifelse
          } ifelse
      } bind
      { } { } { } { } { } { } { } { } { }
      { 2 {cvi { { pop 0 lt { exit } if } loop } repeat } repeat } bind
      {} {} {}
      {} {} {} {} {}
      {} {}
      {} {} {} {} {}
    ] def

    /Erode
    { 7.5 dup 3 -1 roll 0.1 mul exch 0.5 sub mul cvi sub dup mul
      86 0 dtransform dup mul exch dup mul add le
        { pop pop 1.0 1.0 }
        { pop pop 0.0 1.5 }
      ifelse
    } bind def

    /password 5839 def

    /SubrMapOffset #{i_subrmapoffset} def
    /SDBytes 3 def
    /SubrCount 4 def
    end def
  %ADOEndPrivateDict

  currentdict
  end
%ADOEndFontDict
put

__EOM__
end

print <<"__EOM__"
def

%%BeginData: #{$totalsize} Binary Bytes
__EOM__

printf("(Binary) #{$totalsize} StartData ")
